package withSync_advancedLocking;

import java.util.Random;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Created by skazzi on 10/28/15.
 */
public class ChocolateEater extends Thread
{
    private int eaten = 0;
    private Shop[]shops;
    private ReentrantLock lock;

    public ChocolateEater (Shop[] shops, ReentrantLock lock) {
        this.shops = shops;
        this.lock = lock;
        start();
    }

    public int getEaten() {
        return eaten;
    }

    @Override
    public void run() {
        while (true) {
            try {
                // damn im hungry, lets get some chocolate!
                Random rand = new Random();
                int chosenShop = rand.nextInt(4);
                int numberOfChocolates = rand.nextInt(7) + 1;

                if (shops[chosenShop].getNumberOfChocolates() >= numberOfChocolates) {
                    lock.lock();
                    eaten += numberOfChocolates;
                    shops[chosenShop].setNumberOfChocolates(shops[chosenShop].getNumberOfChocolates() - numberOfChocolates);
                    lock.unlock();
                }
                Thread.sleep(500);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
