package withSync_advancedLocking;

import java.util.concurrent.locks.ReentrantLock;

/**
 * Created by skazzi on 10/28/15.
 */
public class Shop extends Thread
{
    private int stock;
    private final int limit = 1000;
    private Warehouse warehouse;
    private ReentrantLock lock;

    public Shop(Warehouse warehouse, ReentrantLock lock) {
        // shops are empty and they need to restock from the warehouse
        this.stock = 0;
        this.warehouse = warehouse;
        this.lock = lock;
    }

    public int getNumberOfChocolates() {
        return stock;
    }

    public void setNumberOfChocolates(int n) {
        this.stock = n;
    }

    @Override
     public void run() {
        while (true) {
            try {
                // we restock if needed
                if (stock < limit) {
                    lock.lock();
                    warehouse.setStorage(warehouse.getStorage() - (limit - stock));
                    stock = limit;
                    lock.unlock();
                }

                // and then we wait for 5 seconds until the next restock from warehouse
                Thread.sleep(5000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public String toString() {
        return "In stock: " + stock + "\n";
    }
}
